var wrapper = document.getElementById("signature-pad");
//var clearButton = wrapper.querySelector("[data-action=clear]");
//var changeColorButton = wrapper.querySelector("[data-action=change-color]");
var undoButton = document.getElementById("btnUndo"); //wrapper.querySelector("[data-action=undo]");
//var savePNGButton = wrapper.querySelector("[data-action=save-png]");
//var saveJPGButton = wrapper.querySelector("[data-action=save-jpg]");
//var saveSVGButton = wrapper.querySelector("[data-action=save-svg]");
var canvas = wrapper.querySelector("canvas");
var signaturePad = new SignaturePad(canvas, {
  // It's Necessary to use an opaque color when saving image as JPEG;
  // this option can be omitted if only saving as PNG or SVG
  backgroundColor: 'rgb(255, 255, 255)'
});


/*function RedrawCanvas() {
	var ctrl = document.getElementById("pattern");
	if (ctrl.value != "") {
		var background = new Image();
		background.src = ctrl.value;
		// Make sure the image is loaded first otherwise nothing will draw.
		background.onload = function() {
			var bgwidth = parseInt(document.querySelector('.signature-pad--body').style.width);
			var bgheight = parseInt(document.querySelector('.signature-pad--body').style.height);
			//var ratio =  Math.max(window.devicePixelRatio || 1, 1);
			//const context = canvas.getContext("2d").scale(ratio, ratio);
			const context = canvas.getContext("2d");
			context.drawImage(background, 0, 0, bgwidth, bgheight);
			setCanvasData(canvasData);
			DrawOverlayText();
		}
	} else {
		setCanvasData(canvasData, true);
		DrawOverlayText();
	}
}*/

// Adjust canvas coordinate space taking into account pixel ratio,
// to make it look crisp on mobile devices.
// This also causes canvas to be cleared.
function resizeCanvas() {
  var data = signaturePad.toData(); // preserve
  // When zoomed out to less than 100%, for some very strange reason,
  // some browsers report devicePixelRatio as less than 1
  // and only part of the canvas is cleared then.
  var ratio =  Math.max(window.devicePixelRatio || 1, 1);

  // This part causes the canvas to be cleared
  canvas.width = canvas.offsetWidth * ratio;
  canvas.height = canvas.offsetHeight * ratio;
  canvas.getContext("2d").scale(ratio, ratio);

  // This library does not listen for canvas changes, so after the canvas is automatically
  // cleared by the browser, SignaturePad#isEmpty might still return false, even though the
  // canvas looks empty, because the internal data of this library wasn't cleared. To make sure
  // that the state of this library is consistent with visual state of the canvas, you
  // have to clear it manually.
  signaturePad.clear();
  //RedrawCanvas();
}

// On mobile devices it might make more sense to listen to orientation change,
// rather than window resize events.
//---window.onresize = resizeCanvas;
resizeCanvas();

function download(dataURL, filename) {
  var blob = dataURLToBlob(dataURL);
  var url = window.URL.createObjectURL(blob);

  var a = document.createElement("a");
  a.style = "display: none";
  a.href = url;
  a.download = filename;

  document.body.appendChild(a);
  a.click();

  window.URL.revokeObjectURL(url);
}

// One could simply use Canvas#toBlob method instead, but it's just to show
// that it can be done using result of SignaturePad#toDataURL.
function dataURLToBlob(dataURL) {
  // Code taken from https://github.com/ebidel/filer.js
  var parts = dataURL.split(';base64,');
  var contentType = parts[0].split(":")[1];
  var raw = window.atob(parts[1]);
  var rawLength = raw.length;
  var uInt8Array = new Uint8Array(rawLength);

  for (var i = 0; i < rawLength; ++i) {
    uInt8Array[i] = raw.charCodeAt(i);
  }

  return new Blob([uInt8Array], { type: contentType });
}

/*clearButton.addEventListener("click", function (event) {
  signaturePad.clear();
});
*/
undoButton.addEventListener("click", function (event) {
  //var data = signaturePad.toData();
  UpdateBackground(false);
  //alert(data.length);
  /*if (data) {
    data.pop(); // remove the last dot or line
    signaturePad.fromData(data);
  }*/
  //ResetCanvas(true);
});
function undo(clear = false) {
  var data = signaturePad.toData();
  //alert(data.length);
  if (data) {
	  if (data.length > 0) {
	    data.pop(); // remove the last dot or line
	    signaturePad.fromData(data, clear);
    }
  }
  //ResetCanvas(true);
}
function redraw(clear = false) {
  var data = signaturePad.toData();
  //alert(data.length);
  if (data) {
	  if (data.length > 0) {
	    //data.pop(); // remove the last dot or line
	    signaturePad.fromData(data, clear);
    }
  }
  //ResetCanvas(true);
}
function getCanvasData() {
	var data = signaturePad.toData();
	return data;
}
function setCanvasData(data, clear = false) {
	if (signaturePad) {
	  if (data) {
	    if (data.length > 0) {
		  //data.pop(); // remove the last dot or line
		  signaturePad.fromData(data, clear);
	    }
	  }
	}
}
/*
changeColorButton.addEventListener("click", function (event) {
  var r = Math.round(Math.random() * 255);
  var g = Math.round(Math.random() * 255);
  var b = Math.round(Math.random() * 255);
  var color = "rgb(" + r + "," + g + "," + b +")";

  signaturePad.penColor = color;
});

savePNGButton.addEventListener("click", function (event) {
  if (signaturePad.isEmpty()) {
    alert("Please provide a signature first.");
  } else {
    var dataURL = signaturePad.toDataURL();
    download(dataURL, "signature.png");
  }
});

saveJPGButton.addEventListener("click", function (event) {
  if (signaturePad.isEmpty()) {
    alert("Please provide a signature first.");
  } else {
    var dataURL = signaturePad.toDataURL("image/jpeg");
    download(dataURL, "signature.jpg");
  }
});

saveSVGButton.addEventListener("click", function (event) {
  if (signaturePad.isEmpty()) {
    alert("Please provide a signature first.");
  } else {
    var dataURL = signaturePad.toDataURL('image/svg+xml');
    download(dataURL, "signature.svg");
  }
});
*/